#ifndef IMAGELIST_H
#define IMAGELIST_H

#include <QListWidget>

namespace NdeWidget {

class ImageList : public QListWidget
{
    Q_OBJECT

    Q_PROPERTY(bool textVisible READ textVisible WRITE setTextVisible NOTIFY textVisibleChanged)
    Q_PROPERTY(QSize itemSize READ itemSize WRITE setItemSize NOTIFY itemSizeChanged)
    Q_PROPERTY(QSize imageSize READ imageSize WRITE setImageSize NOTIFY imageSizeChanged)
public:
    explicit ImageList(QWidget *parent = 0);

    void addImage(const QString &path, QString name = QString());

    QSize itemSize() const;
    void setItemSize(const QSize size);
    QSize imageSize() const;
    void setImageSize(const QSize size);
    bool textVisible() const;
    void setTextVisible(const bool visible);

Q_SIGNALS:
    void textVisibleChanged(bool visible);
    void itemSizeChanged(QSize size);
    void imageSizeChanged(QSize size);

private Q_SLOTS:
    void slotCurrentChanged(QListWidgetItem*current,QListWidgetItem*pre);

protected:
    void resizeEvent(QResizeEvent *e) Q_DECL_OVERRIDE;

private:
    bool m_textVisible;    //是否展示文字
    QSize m_itemSize;      //每一个子项目的尺寸
    QSize m_imageSize;
};

}
#endif // IMAGELIST_H
